;;;;

(use test)

(use symbol-utils)

(test #:foo (symbol->keyword 'foo))

(test-assert (unbound-value? (unbound-value)))

(test-assert (symbol-value symbol->keyword #f))

(test-assert (unspecified? (unspecified-value)))

(test-assert (symbol-printname=? 'foo 'foo))
(test-assert (not (symbol-printname=? 'foo 'bar)))
(test-assert (symbol-printname=? '##sys#list->string '##sys#list->string))
(test-assert (not (symbol-printname=? '##sys#list->string 'list->string)))

(test-assert (not (symbol-printname<? 'foo 'foo)))
(test-assert (symbol-printname<? 'bar 'foo))
(test-assert (not (symbol-printname<? '##sys#list->string '##sys#list->string)))
(test-assert (symbol-printname<? 'list->string '##sys#list->string))

(test 3 (symbol-printname-length 'foo))

(test 3 (max-symbol-printname-length '(a abc ab)))

(test '##foo#bar (make-qualified-symbol "foo" 'bar))

(test-assert (qualified-symbol? '##sys#list->string))
(test-assert (not (qualified-symbol? 'sym)))

(test "##sys#list->string" (symbol->qualified-string '##sys#list->string))
(test "list->string" (symbol->qualified-string 'list->string))

(test-assert (interned-symbol? 'foo))
(test-assert (not (interned-symbol? (gensym))))

(test-assert (not (interned-symbol? (make-qualified-uninterned-symbol "bar" 'foo))))

(test-exit)
